# PanguLU

 **PanguLU** is an open source software package that uses a block sparse structure to solve linear systems A*X=B. It uses a sparse matrix block LU decomposition algorithm. The sparse matrix block LU decomposition algorithm is an algorithm that splits the sparse matrix into multiple sparse matrix blocks, and uses sflu, sparse triangle solution sptrsv, sparse matrix matrix multiplication spgemm and other kernels among the sparse matrix blocks. The algorithm can be used in heterogeneous The distributed platform operates accurately and efficiently.

-------------------

## Introduction

PanguLU is mainly deployed at distributed multi-GPU parallel clusters. PanguLU is implemented in the use of MPI and CUDA,  MPI is used for communication and CUDA is used for GPU computing . We have implemented multi-GPU acceleration and are still actively accelerating.


## Structure of code

```
PanguLU/README      instructions on installation
PanguLU/src         C and CUDA source code, to be compiled into libpangulu.so
PanguLU/test        testing code
PanguLU/icnlude     contains headers archieve libpangulu.so
PanguLU/lib         contains library archieve libpangulu.so
PanguLU/Makefile    top-level Makefile that does installation and testing
PanguLU/make.inc    compiler, compiler flags included in all Makefiles
PanguLU/matrix      a download matrices script and download matrices in here
PanguLU/test_kernel source code and test files for testing sparse kernel perfomance 
PanguLU/script      some python scripts for plotting and shell execution scripts 
PanguLU/figure      Storege of the figures from python scripts for plotting
PanguLU/data        Storage of the data from shell script execution and drawing in csv and xlsx format 
```

## Installation
we use the method is to use make automatic build system.
installation method:
You will need install make.
Frist, in order to use MPI, you need to install mpich (recommended version: mpich-3.3.2).
Second, in order to use NVCC, you need to install CUDA (recommended version: CUDA-11.3).
Third, Specify the installation path to be used in make.inc.
Fianlly, use make for automatic installation.
> **make**

## Execution of PanguLU
PanguLU is to complete the operation of solving AX=b, and the test file is placed in the test folder. The test is to first perform the LU numerical decomposition of the matrix test.mtx, and use Ly=b to complete the lower triangular solution and Ux=y to complete the upper triangular solution test method.
### run command

> **mpirun -np process_number ./PanguLU -NB NB_number -F Smatrix_name**
 
process_number : this process number  
NB_number : the number of processes required is equal to the product of P and Q;  
Smatrix_name : the Matrix name in csr format.(This matrix needs to be decomposed symbolically)

You can also use the run.sh, for example:

> **bash run Smatrix_name NB_number process_number**

### test sample

> **mpirun -np 6 ./PanguLU -NB 2 -F test.mtx**

or use the run.sh:
> **bash run.sh test.mtx 2 6**


In this example,six processes are used to test, the  NB_number is 2 ,P_number is 2,Q_number is 3, matrix name is test.mtx
## Release version
<p align='left'>Oct 19,2021 Version 1.0</p>    
<p align='left'>Jul &nbsp;&thinsp;22,2022 Version 2.0</p>
<p align='left'>Nov 28,2022 Version 2.1</p>
<p align='left'>Apr 02,2023 Version 3.0</p>

 





